/**
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.domainThree.dal.internal;

import java.util.Collection;

import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.domainThree.bl.EntityDomainThree;
import com.btc.ep.domainThree.bl.impl.EntityDomainThreeImpl;
import com.btc.ep.domainThree.bl.repository.EntityDomainThreeRepository;

/**
 * This class is the Repository for Profiles
 * 
 * @author Simon Kollmann
 */

public class EntityDomainThreeRepositoryImpl implements EntityDomainThreeRepository {

    /**
     * Injected by OSGi.
     */
    private BaseRepository<EntityDomainThree> baseRepository;


    /**
     * Set the BaseRepository
     *
     * @param baseRepository The BaseRepository
     */
    public void setBaseRepository(BaseRepository<EntityDomainThree> baseRepository) {
        this.baseRepository = baseRepository;
    }

    @Override
    public EntityDomainThree findEntityDomainThree() {
        Collection<EntityDomainThreeImpl> entityDomainThrees = baseRepository.findAll(EntityDomainThreeImpl.class);

        if (entityDomainThrees != null && !entityDomainThrees.isEmpty()) {
            return entityDomainThrees.iterator().next();
        }
        return null;
    }
    

	@Override
	public EntityDomainThree updateEntityDomainThree(
			EntityDomainThree entityDomainThree) {
		return baseRepository.update(entityDomainThree);
	}
}
