package com.btc.ep.domainThree.dal.tests.it;

import java.io.File;
import java.util.Collection;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.btc.ep.base.bl.ModelElement;
import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.core.Services;
import com.btc.ep.domainThree.bl.EntityDomainThree;
import com.btc.ep.domainThree.bl.impl.EntityDomainThreeImpl;

/**
 * This class tests the DAL save and load operations.
 */

public class IT_DALSaveAndLoadTest extends BaseTest {

	/**
	 * initializes resources before running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * destroys resources after running all tests
	 * 
	 * @throws Exception
	 *             anything
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		destroyPersistenceService();
	}

	/**
	 * initializes before running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@Before
	public void setUp() throws Exception {
		deleteDatabase();
	}

	/**
	 * destroys after running a particular test
	 * 
	 * @throws Exception
	 *             anything
	 */
	@After
	public void tearDown() throws Exception {
	}

	/**
	 * Saves a profile, loads a profile and compares the saved profile to the
	 * load profile. A log in the console explains the tree comparing.
	 *
	 * @throws Exception
	 *             anything
	 */
	@Test
	public void saveProfileAndLoadProfileAndComparingProfilesTest()
			throws Exception {

		EntityDomainThree entitydomainThree = new EntityDomainThreeImpl();

		entitydomainThree.setFilePath(new File("abc.txt"));
		entitydomainThree.setName("profile");

		getPersistenceService().persist(entitydomainThree);

		@SuppressWarnings("unchecked")
		BaseRepository<ModelElement> baseRepository = Services.get(BaseRepository.class);

		baseRepository.update(entitydomainThree);

		// store in DataBaseFile [commit();]
		baseRepository.save();

		getPersistenceService().clear();

		Collection<EntityDomainThreeImpl> res = baseRepository.findAll(EntityDomainThreeImpl.class);

		EntityDomainThree entitydomainThreeLoaded = res.iterator().next();

//		Verifier verifier = new Verifier();
//		verifier.start(profile, profile2);

		getPersistenceService().remove(entitydomainThreeLoaded);
	}
}
