/**
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.domainTwo.dal.internal;

import java.util.Collection;

import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.domainTwo.bl.EntityDomainTwo;
import com.btc.ep.domainTwo.bl.impl.EntityDomainTwoImpl;
import com.btc.ep.domainTwo.bl.repository.EntityDomainTwoRepository;

/**
 * This class is the Repository for Profiles
 * 
 * @author Simon Kollmann
 */

public class EntityDomainTwoRepositoryImpl implements EntityDomainTwoRepository {

    /**
     * Injected by OSGi.
     */
    private BaseRepository<EntityDomainTwo> baseRepository;


    /**
     * Set the BaseRepository
     *
     * @param baseRepository The BaseRepository
     */
    public void setBaseRepository(BaseRepository<EntityDomainTwo> baseRepository) {
        this.baseRepository = baseRepository;
    }

    @Override
    public EntityDomainTwo findEntityDomainTwo() {
        Collection<EntityDomainTwoImpl> entitydomainTwos = baseRepository.findAll(EntityDomainTwoImpl.class);

        if (entitydomainTwos != null && !entitydomainTwos.isEmpty()) {
            return entitydomainTwos.iterator().next();
        }
        return null;
    }
    

	@Override
	public EntityDomainTwo updateEntityDomainTwo(
			EntityDomainTwo entitydomainTwo) {
		return baseRepository.update(entitydomainTwo);
	}
}
